
#include <algorithm>
#include <iostream>
#include <iterator>
#include <string>
#include <vector>

#include "MyService.hpp"

#include <RCF/RCF.hpp>

class callbacks {
public:
	void callback()
	{
		std::cout << "callback called" << std::endl;
	}
};

int main()
{
    RCF::RcfInitDeinit rcfInit;

    try
    {
	RCF::RcfServer callbackServer(RCF::TcpEndpoint(0));
   	callbackServer.setSessionTimeoutMs(60*1000);
    	callbackServer.setSessionHarvestingIntervalMs(30*1000);
	callbacks cbimpl;
    	callbackServer.bind<MyServiceCallback>(cbimpl);
    	callbackServer.start();
	RcfClient<MyService> client(RCF::TcpEndpoint("127.0.0.1", 50001));
   	RCF::createCallbackConnection(client, callbackServer); 
       client.test();
 	client.test1();
	client.test2();
	sleep(60*60*1000);
    }
    catch(const RCF::Exception & e)
    {
        std::cout << "Caught exception:\n";
        std::cout << e.getError().getErrorString() << std::endl;
        return 1;
    }

    return 0;
}
