
#include <algorithm>
#include <iostream>
#include <string>
#include <vector>

#include <RCF/RCF.hpp>

#include "MyService.hpp"

RCF::ClientTransportAutoPtr gCallbackTransportPtr;
static void
onCallback(RCF::RcfSessionPtr sessionPtr, 
           RCF::ClientTransportAutoPtr clientptr) {
  std::cout << "Create connection" << std::endl;
 gCallbackTransportPtr = clientptr;
}

static void
onCallbackDisconnect(RCF::RcfSession &s)
{
  std::cout << "disconnect" << std::endl;
  s.setCloseSessionAfterWrite(true);
  s.deleteSessionObject<std::string>();
}

class MyServiceImpl
{
public:
    // Reverses the order of strings in the vector.
    void reverse(std::vector<std::string> &v)
    {
        std::cout << "Reversing a vector of strings...\n";
        std::vector<std::string> w;
        std::copy(v.rbegin(), v.rend(), std::back_inserter(w));
        v.swap(w);
    }

    void test()
    {
	RCF::getCurrentRcfSession().setOnDestroyCallback(boost::bind(onCallbackDisconnect, _1));
     std::cout << "test"<< std::endl;
    }
    void test1()
    {
        std::cout << "test1" << std::endl;
    }
    void test2()
    {
        std::cout << "test2" << std::endl;
    }
};

int main()
{
    RCF::RcfInitDeinit rcfInit;

    // Start a TCP server on port 50001, and expose MyServiceImpl.
    MyServiceImpl myServiceImpl;
    RCF::RcfServer server( RCF::TcpEndpoint("0.0.0.0", 50001) );
    server.setSessionTimeoutMs(60*1000);
    server.setSessionHarvestingIntervalMs(40*1000);
    server.setOnCallbackConnectionCreated(onCallback);

    server.bind<MyService>(myServiceImpl);
    server.start();
	sleep(10);
	RcfClient<MyServiceCallback> callbackClient( gCallbackTransportPtr );
        callbackClient.callback();

    std::cout << "Press Enter to exit..." << std::endl;
    std::cin.get();

    return 0;
}
